![Toolsmith][logo] Toolsmith
======
[![npm version][npm-image]][npm-url]
[![pipeline status][pipeline-image]][pipeline-url]
[![coverage status][coverage-image]][coverage-url]
[![standard-js][standard-image]][standard-url]
[![conventional commits][commits-image]][commits-url]

Yet another CLI tool framework.

## Installation

```
npm install toolsmith
```

## Basic Example

```javascript
#!/usr/bin/env node
const command = require("toolsmith")

command()
  .option('foo')
  .parameter('bar')
  .handler((ctx, args, opts) => {
    if (opts.foo) {
      ctx.log('foo is enabled')
    }
    ctx.log('bar says ' + bar)
  });
```

```
$ ./example.js --foo hello
foo is enabled
bar says hello

$ ./example.js --help
Usage: example.js [OPTIONS...] <bar>
Parameters:
  bar
Options:
  -h,--help  You are here.
  -f,--foo
```

[logo]: https://gitlab.com/cptpackrat/toolsmith/raw/master/doc/logo.png
[npm-image]: https://img.shields.io/npm/v/toolsmith.svg
[npm-url]: https://www.npmjs.com/package/toolsmith
[pipeline-image]: https://gitlab.com/cptpackrat/toolsmith/badges/master/pipeline.svg
[pipeline-url]: https://gitlab.com/cptpackrat/toolsmith/commits/master
[coverage-image]: https://gitlab.com/cptpackrat/toolsmith/badges/master/coverage.svg
[coverage-url]: https://gitlab.com/cptpackrat/toolsmith/commits/master
[standard-image]: https://img.shields.io/badge/code%20style-standard-brightgreen.svg
[standard-url]: http://standardjs.com/
[commits-image]: https://img.shields.io/badge/conventional%20commits-1.0.0-yellow.svg
[commits-url]: https://www.conventionalcommits.org
